unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  lNetComponents, StdCtrls, Buttons, ComCtrls, lNet, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    bt_connect: TButton;
    bt_counter_read1: TButton;
    bt_counter_clear0: TButton;
    bt_counter_clear1: TButton;
    bt_counter_readall: TButton;
    bt_counter_clearall: TButton;
    bt_disconnect: TButton;
    bt_outputs_read: TButton;
    bt_inputs_read: TButton;
    bt_counter_read0: TButton;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    cb_input0: TCheckBox;
    cb_input1: TCheckBox;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    ed_counter0: TEdit;
    ed_counter1: TEdit;
    ed_interval: TEdit;
    ed_password: TEdit;
    ed_port: TEdit;
    ed_ip: TEdit;
    gb_io: TGroupBox;
    gb_connection: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LTCPComponent1: TLTCPComponent;
    StatusBar1: TStatusBar;
    timer_polling: TTimer;
    procedure LTCPComponent1Connect(aSocket: TLSocket);
    procedure LTCPComponent1Disconnect(aSocket: TLSocket);
    procedure LTCPComponent1Error(const msg: string; aSocket: TLSocket);
    procedure LTCPComponent1Receive(aSocket: TLSocket);
    procedure ed_intervalChange(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure bt_connectClick(Sender: TObject);
    procedure bt_counter_clear0Click(Sender: TObject);
    procedure bt_counter_clear1Click(Sender: TObject);
    procedure bt_counter_clearallClick(Sender: TObject);
    procedure bt_counter_read0Click(Sender: TObject);
    procedure bt_counter_read1Click(Sender: TObject);
    procedure bt_counter_readallClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure bt_inputs_readClick(Sender: TObject);
    procedure bt_outputs_readClick(Sender: TObject);
    procedure cb_output0MouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cb_output1MouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

function HexToInt(HexString : String) : longWord;
var CharCount           : integer;
    HexCharValue        : longWord;
    HexValue            : longWord;
begin
   HexValue := 0;
   HexString := UpperCase(HexString);
   for CharCount := 1 to length(HexString) do
   begin
     HexCharValue := ord(HexString[CharCount]);
     if HexCharValue > 57 then
        HexCharValue := HexCharValue - 55
     else
        HexCharValue := HexCharValue - 48;
     HexCharValue := HexCharValue shl ((length(HexString) - CharCount) *  4);
     HexValue := HexValue or HexCharValue;
   end;
   HexToInt := HexValue;
end;

procedure TForm1.bt_connectClick(Sender: TObject);
begin
  if ed_ip.Text <> '' then
  begin
    bt_connect.Enabled := false;
    LTCPComponent1.Connect(ed_ip.Text, strtoint(ed_port.Text));
  end;
end;

procedure TForm1.bt_disconnectClick(Sender: TObject);
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
  LTCPComponent1.Disconnect;
end;

procedure TForm1.LTCPComponent1Connect(aSocket: TLSocket);
begin
  StatusBar1.SimpleText := 'Connected to ' + ed_ip.Text;
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  gb_io.Enabled := True;
end;

procedure TForm1.LTCPComponent1Disconnect(aSocket: TLSocket);
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
  LTCPComponent1.Disconnect;
end;

procedure TForm1.LTCPComponent1Error(const msg: string; aSocket: TLSocket);
begin
  StatusBar1.SimpleText := 'Error: '+ msg;
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
  LTCPComponent1.Disconnect;
end;

procedure TForm1.bt_inputs_readClick(Sender: TObject);
begin
  LTCPComponent1.SendMessage
      ('GET /input?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_outputs_readClick(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /output?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.cb_output0MouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if cb_output0.Checked then
    LTCPComponent1.SendMessage
      ('GET /outputaccess0?PW=' + ed_password.Text + '&State=ON&',nil)
  else
    LTCPComponent1.SendMessage
      ('GET /outputaccess0?PW=' + ed_password.Text + '&State=OFF&',nil)
end;

procedure TForm1.cb_output1MouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if cb_output1.Checked then
    LTCPComponent1.SendMessage
      ('GET /outputaccess1?PW=' + ed_password.Text + '&State=ON&',nil)
  else
    LTCPComponent1.SendMessage
      ('GET /outputaccess1?PW=' + ed_password.Text + '&State=OFF&',nil)
end;

procedure TForm1.bt_counter_clear0Click(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counterclear0?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_counter_clear1Click(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counterclear1?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_counter_clearallClick(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counterclear?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_counter_read0Click(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counter0?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_counter_read1Click(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counter1?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.bt_counter_readallClick(Sender: TObject);
begin
  LTCPComponent1.SendMessage
    ('GET /counter?PW=' + ed_password.Text + '&',nil);
end;

procedure TForm1.LTCPComponent1Receive(aSocket: TLSocket);
  var ReceiveString : String;
    SemiPosition : integer;
    OutputValue : word;
    InputValue : word;
begin
  aSocket.GetMessage(ReceiveString);
  if Receivestring[1] = 'o' then
  begin
    OutputValue := HextoInt(copy(ReceiveString,
     pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)-1));
    if OutputValue and 1 = 1 then
      cb_output0.Checked := True
    else
      cb_output0.Checked := False;
    if OutputValue and 2 = 2 then
      cb_output1.Checked := True
    else
      cb_output1.Checked := False;
  end;
  if Receivestring[1] = 'i' then
  begin
    InputValue := HextoInt(copy(ReceiveString,
       pos(';',ReceiveString)+1,
       length(ReceiveString)-pos(';',ReceiveString)-1));
    if InputValue and 1 = 1 then
      cb_input0.Checked := True
    else
      cb_input0.Checked := False;
    if InputValue and 2 = 2 then
      cb_input1.Checked := True
    else
      cb_input1.Checked := False;
  end;
  if Receivestring[1] = 'c' then
  begin
    if copy(ReceiveString, 8, 1) = '0' then
      ed_counter0.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = '1' then
      ed_counter1.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = ';' then
    begin
      ReceiveString[8] := ' ';
      ed_counter0.Text := copy(ReceiveString, 9, pos(';',ReceiveString)-9);
      ed_counter1.Text := copy(ReceiveString,
        pos(';',ReceiveString)+1,
        length(ReceiveString)-pos(';',ReceiveString)-1);
    end;
  end;
end;

procedure TForm1.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval:= strtoint(ed_interval.text);
end;

procedure TForm1.timer_pollingTimer(Sender: TObject);
begin
  if LTCPComponent1.Connected and cb_output_polling.Checked then
    LTCPComponent1.SendMessage('GET /output?PW=' + ed_password.Text + '&',nil);
  if LTCPComponent1.Connected and cb_input_polling.Checked then
    LTCPComponent1.SendMessage('GET /input?PW=' + ed_password.Text + '&',nil);
  if LTCPComponent1.Connected and cb_counter_polling.Checked then
    LTCPComponent1.SendMessage('GET /counter?PW=' + ed_password.Text + '&',nil);
end;

initialization
  {$I unit1.lrs}

end.

